<?php
class EmbeddedDecorator extends Extension {
	function Content() {
		return preg_replace_callback('/\$Embed\[[\s\n]*(?P<all>(?P<call>(?P<method>\w+(?:::\w+)?)\((?P<params>[^\n]+)\)[\s\n]*;?[\s\n]*)+)\]/', array($this, "parseEmbed"), htmlspecialchars_decode($this->owner->Content));
	}

	function parseEmbed($embedCode) {
//		return "Call = ".$embedCode['all'];
//		return preg_replace_callback('/\$Embed\[[\s\n]*(?P<all>(?P<call>(?P<method>\w+)\((?P<params>[^)\s\n]+)\)[\s\n]*;?[\s\n]*)+)]/', array($this, "parseFunctions"), $this->owner->Content);
		$functionCalls = preg_split('/(?P<call>(?:\w+(?:::\w+)?)\((?:[^;\n]+)\)[\s\n]*;?[\s\n]*)/', $embedCode['all'],-1, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
//		$output = 'start:<br/>\n';
//		foreach ($functionCalls as $p) {
//			$output = $output.'	param: '.$p.'<br/>\n';
//		}
//		return $output;

		$output = '';
		foreach ($functionCalls as $fcall) {
			$output = $output.preg_replace_callback('/(?P<call>(?P<method>\w+(?:::\w+)?)\((?P<params>[^\n]+)\));?/', array($this, "parseFunctions"), $fcall);
		}
		return $output;
	}

	function parseFunctions($embedCode) {
//		return "Call = ".$embedCode['call'].'</br>';

		$method = $embedCode['method'];
		$params = $this->parseParams($embedCode['params']);

//		$output = 'function: '.$method.'<br/>\n';
//		foreach ($params as $p) {
//			$output = $output.'	param: '.$p.'<br/>\n';
//		}
//		return $output.'</br>'.
		return call_user_func_array(strpos($method,":")?$method:array($this->owner, $method),$params);

	}

	function splitParams($paramsList) {
		return preg_split('/,|,?[^(]("[^"]*"),?|,?[^(](\'[^\']*\'),?|,?\[([^]\s\n]+)\],?/', $paramsList,-1, PREG_SPLIT_DELIM_CAPTURE);
	}
	function parseParams($paramsList) {
		$firstLevel = $this->splitParams($paramsList);
		$secondLevel = array();
		foreach ($firstLevel as $fp) {
			$sp = $this->splitParams($fp);
			array_push($secondLevel,count($sp)>1?$sp:preg_replace('/(^["\'])?([^\1]*)\1/','\2',$fp));
		}
		return $secondLevel;
	}


}
?>