<?php
define('defaultID', 'GMapId');
define('defaultMapType', 'HYBRID');
class GoogleMapsDecorator extends Extension {

	//private static $googleMapsVarsPrefix = '';
	private static $mapVarPrefix = 'embedded_gm_map_';
	private static $optionsVarPrefix = 'embedded_gm_options_';

	static function set_googleMaps_vars_prefix($newPrefix) {
		self::$mapVarPrefix = $newPrefix.'map_';
		self::$optionsVarPrefix = $newPrefix.'options_';
	}


	function GoogleMap($latitude,$longitude,$zoom,$mapType=defaultMapType,$id=defaultID,$xSize="100%",$ySize="300px") {
		Requirements::javascript("http://maps.google.com/maps/api/js?sensor=false");
		Requirements::javascript("embedded/javascript/emdedGoogleMap.js");
		Requirements::customScript('
		    var '.self::$optionsVarPrefix.$id.' = {};
			var '.self::$mapVarPrefix.$id.' = addGoogleMap('.$latitude.','.$longitude.','.$zoom.',google.maps.MapTypeId.'.((empty($mapType))?defaultMapType:$mapType).','.self::$optionsVarPrefix.$id.',"'.$id.'");
		');

		return '<div id="'.$id.'" class="GoogleMap" style="width:'.$xSize.'; height:'.$ySize.'"></div>';
	}

	function GoogleMapMarker($latitude,$longitude,$title,$content="",$id=defaultID) {
		Requirements::customScript('
			addMarker('.$latitude.','.$longitude.',"'.$title.'","'.$content.'",'.self::$mapVarPrefix.$id.');
		');
	}

	function GoogleMapOption($name,$value,$id=defaultID) {
		Requirements::customScript('
			setMapOption("'.$name.'",'.$value.','.self::$optionsVarPrefix.$id.','.self::$mapVarPrefix.$id.');
		');
	}
	function GoogleMapOptionsObject($newOptions,$id=defaultID) {
		Requirements::customScript('
			updateMapOptions('.$newOptions.','.self::$optionsVarPrefix.$id.','.self::$mapVarPrefix.$id.');
		');
	}

	function GoogleMapRefresh($id=defaultID) {
		Requirements::customScript('
			refreshMap('.self::$optionsVarPrefix.$id.','.self::$mapVarPrefix.$id.');
		');
	}

}

?>