function addGoogleMap(latitude, longitude, mapZoom, mapType, mapOptions,
		elementId) {
	var latlng = new google.maps.LatLng(latitude, longitude);
	mapOptions["zoom"] = mapZoom;
	mapOptions["center"] = latlng;
	mapOptions["mapTypeId"] = mapType;
	return new google.maps.Map(document.getElementById(elementId), mapOptions);
}

function addMarker(latitude, longitude, title, content, mapId) {
	var latlng = new google.maps.LatLng(latitude, longitude);
	var marker = new google.maps.Marker( {
		position : latlng,
		map : mapId,
		title : title
	});
	var infowindow = new google.maps.InfoWindow( {
		content : content
	});
	infowindow.open(mapId, marker);
}

function updateMapOptions(newOptions, mapOptions, mapId) {
	//alert("newOptions=" + newOptions);
	//alert("mapOptions=" + mapOptions);
	mapOptions=MergeRecursive(mapOptions,newOptions);
	//alert("mergedOptions=" + mapOptions);
	mapId.setOptions(mapOptions);
}

function setMapOption(key, value, mapOptions, mapId) {
	mapOptions[key] = value;
	mapId.setOptions(mapOptions);
}

function refreshMap(mapOptions, mapId) {
	mapId.setOptions(mapOptions);
}

function MergeRecursive(obj1, obj2) {
	for ( var o in obj2) {
		try {
			if (obj2[o].constructor == Object) {
				obj1[o] = MergeRecursive(obj1[o], obj2[o]);
			} else {
				obj1[o] = obj2[o];
			}
		} catch (e) {
			obj1[o] = obj2[o];
			//alert("MergeRecursive error:"+e);
		}
	}
	return obj1;
}
